<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | SocialShare Plugin 1.2                                                    |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | Plugin administration page                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009-2011 by the following authors:                         |
// |                                                                           |
// | Authors: Greg Gillis - greg DOT gillis AT sillig DOT com                  |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package SocialShare
*/

require_once '../../../lib-common.php';

//Do I really need the tokens?
require_once '../../auth.inc.php';

$display = '';

// Ensure user even has the rights to access this page
if (! SEC_hasRights('socialshare.admin')) {
    $display .= COM_siteHeader('menu', $MESSAGE[30])
             . COM_showMessageText($MESSAGE[29], $MESSAGE[30])
             . COM_siteFooter();

    // Log attempt to access.log
    COM_accessLog("User {$_USER['username']} tried to illegally access the SocialShare plugin administration screen.");

    echo $display;
    exit;
}

//---------------------------------------------
/**
* Shows the socialshare item  editor
*
* This will show an edit form.  
*
* @param    string  $sid    ID of item to edit
* @return   string          HTML for  editor
*
*/
function editshare ($sid = '')
{
    global $_CONF, $_GROUPS, $_TABLES, $_USER, $LANG01, $LANG21, $LANG_ACCESS,
           $LANG_ADMIN, $MESSAGE, $LANG_SOCIALSHARE_0, $LANG_SOCIALSHARE_0;

    $retval = '';

// If we are editing an existing entry get the data from the database
    if (!empty($sid)) {
        $sql['mysql'] = "SELECT * FROM {$_TABLES['socialshare']} WHERE sid ='$sid'";

        $result = DB_query($sql);
        $A = DB_fetchArray($result);

    } else {
// If this is a new entry setup the default data	
        $A['sid'] = 0;
        $A['shareorder'] = 0;
        $A['shareurl'] = '';
        $A['sharetitle'] = '';
        $A['shareimage'] = '';		
        $A['is_enabled'] = 1;
		$A['owner_id'] = 2;
    }

// Set the template vars	
    $share_templates = new Template($_CONF['path_html'] . 'admin/plugins/socialshare/templates/');
    $share_templates->set_file('editor','shareeditor.thtml');
    $share_templates->set_var('site_url', $_CONF['site_url']);
    $share_templates->set_var('xhtml', XHTML);
    $share_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
    $share_templates->set_var('layout_url', $_CONF['layout_url']);
    $share_templates->set_var('start_share_editor', COM_startBlock ($LANG_SOCIALSHARE_0[1],'', COM_getBlockTemplate ('_admin_share', 'header')));

	
// Setup the delete button
        $delbutton = '<input type="submit" value="' . $LANG_SOCIALSHARE_0[8] . '" name="mode"%s' . XHTML . '>';
        $jsconfirm = ' onclick="return confirm(\'' . $LANG_SOCIALSHARE_0[9] . '\');"';
        $share_templates->set_var ('delete_option', sprintf ($delbutton, $jsconfirm));
        $share_templates->set_var ('delete_option_no_confirmation', sprintf ($delbutton, ''));

//ShareSID
    $share_templates->set_var('share_sid', $A['sid']);

//Sharetitle
    $share_templates->set_var('lang_sharetitle', $LANG_SOCIALSHARE_0[19]);

//Save button text	
    $share_templates->set_var('lang_save', $LANG_SOCIALSHARE_0[3]);
	
//Cancel button text	
    $share_templates->set_var('lang_cancel', $LANG_SOCIALSHARE_0[4]);

//URL Description	
    $share_templates->set_var('lang_shareurl', $LANG_SOCIALSHARE_0[5]);	
	
//image Description	
    $share_templates->set_var('lang_shareimage', $LANG_SOCIALSHARE_0[6]);		

//Share URL	
    $share_templates->set_var ('share_url',htmlspecialchars (stripslashes ($A['shareurl'])));
	
//Share Title	
    $share_templates->set_var ('share_title',htmlspecialchars (stripslashes ($A['sharetitle'])));	
	
//Share image	
    $share_templates->set_var ('share_image',htmlspecialchars (stripslashes ($A['shareimage'])));
		
//Enabled Text
    $share_templates->set_var('lang_enabled', $LANG_SOCIALSHARE_0[2]);

//Show enabled checkbox	
    if ($A['is_enabled'] == 1) {
        $share_templates->set_var('is_enabled', 'checked="checked"');
    } else {
        $share_templates->set_var('is_enabled', '');
    }

//Show the owner and pass the owner_id
    $share_templates->set_var('lang_owner', $LANG_ACCESS['owner']);
    $ownername = COM_getDisplayName ($A['owner_id']);
    $share_templates->set_var('owner_username', DB_getItem($_TABLES['users'],'username', "uid = '{$A['owner_id']}'"));
    $share_templates->set_var('owner_name', $ownername);
    $share_templates->set_var('owner', $ownername);
    $share_templates->set_var('owner_id', $A['owner_id']);

	
//GTG - NOT IMPLIMENTED YET	
//Grab all of the icon names to compare with and add a grey background if already used				
        $sqlC['mysql'] = "SELECT shareimage FROM {$_TABLES['socialshare']}";

        $resultC = DB_query($sqlC);
		$nrowsC = DB_numRows($resultC);		
//		$C = DB_fetchArray($resultC);
//echo "NUMROWS = ".$nrows;
//print_r($resultC);
	








    for ($i = 0; $i < $nrowsC; $i++) {
        $C = DB_fetchArray($resultC);
//echo "<br>C = ".$C['shareimage'];
    $Cout .= array ($C);
		}	


	
//show available icons with radio selector
    $share_templates->set_var('lang_icon', $LANG_SOCIALSHARE_0[7]);
	if ($handle = opendir($_CONF['path_html'].'/socialshare/images')) {

	$icon_selection = '<table  border="0" align="right" cellpadding="1" cellspacing="1"> <tbody>';
	
	$count = 1;
    while (false !== ($file = readdir($handle))) {
	
        if ($file != "." && $file != ".." && $file != "Thumb.db") {

		if ($count == 1){
		$icon_selection .= '<tr>';
		}
		
	//remove the extension from the $file and add the trimmed string to filene (file no extension)
		$ext = strrchr($file, '.'); 
			if($ext !== false) 
			{ 
			$filene = substr($file, 0, -strlen($ext)); 
			} 


			
			
			
		
			
	
// GTG not impremented yet		
//		if($C['shareimage'] == $file){
//			    $icon_selection .= "<td style='width:150pt;text-align:right';background:grey>".$filene."&nbsp;<img src='/socialshare/images/".$file."'></td>";
//				$icon_selection .= "<td style='width:150pt;border-top:solid windowtext 1.0pt;border-left:solid windowtext 1.0pt;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:green;text-align:right'><b>".$filene."&nbsp;</b><img src='/socialshare/images/".$file."'><input type='radio' name='shareimage' value='".$file."' checked='true'/></td>";
//			}else{
			
//if the filename matches what is in the database then make the background yellow to make it easier to find on screen			
			if ($A['shareimage'] == $file){			
				$icon_selection .= "<td style='width:150pt;border-top:solid windowtext 1.0pt;border-left:solid windowtext 1.0pt;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:yellow;text-align:right'><b>".$filene."&nbsp;</b><img src='/socialshare/images/".$file."'><input type='radio' name='shareimage' value='".$file."' checked='true'/></td>";
			}else{
				$icon_selection .= "<td style='width:150pt;text-align:right'>".$filene."&nbsp;<img src='/socialshare/images/".$file."'><input type='radio' name='shareimage' value='".$file."'/></td>";
			}
//		}			

//show icons 4 row across
		if ($count == 4){
		$icon_selection .= '</tr>';
		$count = 0;		
		}
		
		$count++;
		}


    
}	
//if we get the the end and it is not an even count of 4 then close the /tr	
		if ($count < 4){
		$icon_selection .= '</tr>';
		}

		$icon_selection .= 	'</tbody></table>';
	
    closedir($handle);
}	
    $share_templates->set_var('icon_selection', $icon_selection);	

	
//finishing up	
    $share_templates->set_var('gltoken_name', CSRF_TOKEN);
    $share_templates->set_var('gltoken', SEC_createToken());
    $share_templates->set_var ('end_block', COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer')));
    $share_templates->parse('output', 'editor');
    $retval .= $share_templates->finish($share_templates->get_var('output'));

    return $retval;
}


function listshare()
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG21, $LANG_SOCIALSHARE_0, $_IMAGE_TYPE;



    $retval = '';
    $token = SEC_createToken();

    // writing the menu on top
    $menu_arr = array (
        array('url' => $_CONF['site_admin_url'] . '/plugins/socialshare/index.php?mode=edit',
              'text' => $LANG_ADMIN['create_new']),
        array('url' => $_CONF['site_admin_url'],
              'text' => $LANG_ADMIN['admin_home'])
    );

    $retval .= COM_startBlock($LANG_SOCIALSHARE_0[11], '',
                              COM_getBlockTemplate('_admin_block', 'header'));
    $retval .= SHARE_createMenu(
        $menu_arr,
        $LANG_SOCIALSHARE_0[10],
        $_CONF['layout_url'] . '/images/icons/block.'. $_IMAGE_TYPE
    );

$show_icons = plugin_itemdisplay_socialshare(0,'admin_page');

$retval .= "<center>".$show_icons[1]."</center>"; 
    reordershare();

    // writing the list
    $header_arr = array(      # display 'text' and use table field 'field'
        array('text' => $LANG_SOCIALSHARE_0[22], 'field' => 'edit', 'sort' => false),
        array('text' => $LANG_SOCIALSHARE_0[24], 'field' => 'shareorder', 'sort' => true),
        array('text' => $LANG_SOCIALSHARE_0[27], 'field' => 'move', 'sort' => false),
        array('text' => $LANG_SOCIALSHARE_0[19], 'field' => 'sharetitle', 'sort' => true),
        array('text' => $LANG_SOCIALSHARE_0[20], 'field' => 'shareimage', 'sort' => false),
        array('text' => $LANG_SOCIALSHARE_0[23], 'field' => 'owner_id', 'sort' => false),
        array('text' => $LANG_SOCIALSHARE_0[2], 'field' => 'is_enabled', 'sort' => false)
    );

    $defsort_arr = array('field' => 'shareorder', 'direction' => 'asc');

    $text_arr = array(
        'has_extras' => true,
        'form_url'   => $_CONF['site_admin_url'] . '/plugins/socialshare/index.php'
    );

    $query_arr = array(
        'table' => 'socialshare',
        'sql' => "SELECT * FROM {$_TABLES['socialshare']}",
        'query_fields' => array('sharetitle', 'shareurl'),
//        'default_filter' => COM_getPermSql ('AND')
    );

    $form_arr = array('bottom' => '<input type="hidden" name="shareenabler" value="1"' . XHTML . '>');

    $retval .= SHARE_list(
        'socialshare', 'SHARE_getListField', $header_arr, $text_arr,
        $query_arr, $defsort_arr, '', $token, '', $form_arr
    );

    $retval .= COM_endBlock(COM_getBlockTemplate('_admin_block', 'footer'));

    return $retval;
}


/**
* Creates a list of data with a search, filter, clickable headers etc.
*
* @param    string  $component      name of the list
* @param    string  $fieldfunction  name of the function that handles special entries
* @param    array   $header_arr     array of header fields with sortables and table fields
* @param    array   $text_arr       array with different text strings
* @param    array   $query_arr      array with sql-options
* @param    array   $defsort_arr    default sorting values
* @param    string  $filter         additional drop-down filters
* @param    string  $extra          additional values passed to fieldfunction
* @param    array   $options        array of options - intially just used for the Check-All feature
* @param    array   $form_arr       optional extra forms at top or bottom
* @return   string                  HTML output of function
*
*/
function SHARE_list($component, $fieldfunction, $header_arr, $text_arr,
            $query_arr, $defsort_arr, $filter = '', $extra = '',
            $options = '', $form_arr='')
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG_ACCESS, $LANG01, $_IMAGE_TYPE, $MESSAGE;

    // set all variables to avoid warnings
    $retval = '';
    $filter_str = '';
    $order_sql = '';
    $limit = '';
    $prevorder = '';
    if (isset ($_GET['prevorder'])) { # what was the last sorting?
        $prevorder = COM_applyFilter ($_GET['prevorder']);
    }

    $query = '';
    if (isset ($_REQUEST['q'])) { // get query (text-search)
        $query = strip_tags(COM_stripslashes($_REQUEST['q']));
    }

    $query_limit = '';
    if (isset($_REQUEST['query_limit'])) { // get query-limit (list-length)
        $query_limit = COM_applyFilter($_REQUEST['query_limit'], true);
        if ($query_limit == 0) {
            $query_limit = 50;
        }
    }

    // we assume that the current page is 1 to set it.
    $curpage = 1;
    $page = '';
    // get the current page from the interface. The variable is linked to the
    // component, i.e. the plugin/function calling this here to avoid overlap
    if (isset ($_REQUEST[$component . 'listpage'])) {
        $page = COM_applyFilter ($_REQUEST[$component . 'listpage'], true);
        $curpage = $page;
    }
    if ($curpage <= 0) {
        $curpage = 1; #current page has to be larger 0
    }

    $form_url = ''; # what is the form-url for the search button and list sorters?
    if (!empty ($text_arr['form_url'])) {
        $form_url = $text_arr['form_url'];
    }


    # get all template fields.
    $admin_templates = new Template($_CONF['path_html'] . 'admin/plugins/socialshare/templates/lists');
    $admin_templates->set_file (array (
        'search' => 'searchmenu.thtml',
        'list'   => 'list.thtml',
        'header' => 'header.thtml',
        'row'    => 'listitem.thtml',
        'field'  => 'field.thtml'
    ));

    # insert std. values into the template
    $admin_templates->set_var( 'xhtml', XHTML );
    $admin_templates->set_var('site_url', $_CONF['site_url']);
    $admin_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
    $admin_templates->set_var('layout_url', $_CONF['layout_url']);
    $admin_templates->set_var('form_url', $form_url);
    $admin_templates->set_var('lang_edit', $LANG_SOCIALSHARE_0[22]);
    if (isset($form_arr['top'])) {
        $admin_templates->set_var('formfields_top', $form_arr['top']);
echo "form_arr['top'] = ".$form_arr['top'];		
    }
    if (isset($form_arr['bottom'])) {
        $admin_templates->set_var('formfields_bottom', $form_arr['bottom']);
    }

//////GTG - Delete from template	
        $admin_templates->set_var('show_deleteimage','display:none;');

    # define icon paths. Those will be transmitted to $fieldfunction.
    $icons_type_arr = array('edit', 'copy', 'list', 'addchild');
    $icon_arr = array();
    foreach ($icons_type_arr as $icon_type) {
        $icon_url = "{$_CONF['layout_url']}/images/$icon_type.$_IMAGE_TYPE";
        $icon_arr[$icon_type] = COM_createImage($icon_url, $LANG_ADMIN[$icon_type]);
    }

	
    $has_extras = '';
    if (isset($text_arr['has_extras'])) { # does this one use extras? (search, google paging)
        $has_extras = $text_arr['has_extras'];
    }
    if ($has_extras) { // show search
        $admin_templates->set_var('lang_search', $LANG_ADMIN['search']);
        $admin_templates->set_var('lang_submit', $LANG_ADMIN['submit']);
        $admin_templates->set_var('lang_limit_results',
                                  $LANG_ADMIN['limit_results']);
        $admin_templates->set_var('last_query', htmlspecialchars($query));
        $admin_templates->set_var('filter', $filter);

    }
	

    $sql_query = addslashes($query); // replace quotes etc for security
    $sql = $query_arr['sql']; // get sql from array that builds data

    $order_var = ''; # number that is displayed in URL
    $order = '';     # field that is used in SQL
    $order_var_link = ''; # Variable for google paging.

    // is the order set in the link (when sorting the list)
    if (!isset ($_GET['order'])) {
        $order = $defsort_arr['field']; // no, get the default
    } else {
        $order_var = COM_applyFilter ($_GET['order'], true);
        $order_var_link = "&amp;order=$order_var"; # keep the variable for the google paging
        $order = $header_arr[$order_var]['field'];  # current order field name
    }
    $order_for_query = $order;

    $direction = '';
    if (!isset ($_GET['direction'])) { # get direction to sort after
        $direction = $defsort_arr['direction'];
    } else {
        $direction = COM_applyFilter ($_GET['direction']);
    }
    $direction = strtoupper ($direction);
    if ($order == $prevorder) { #reverse direction if prev. order was the same
        $direction = ($direction == 'DESC') ? 'ASC' : 'DESC';
    } else {
        $direction = ($direction == 'DESC') ? 'DESC' : 'ASC';
    }

    if ($direction == 'ASC') { # assign proper arrow img name dep. on sort order
        $arrow = 'bararrowdown';
    } else {
        $arrow = 'bararrowup';
    }
    # make actual order arrow image
    $img_arrow_url = "{$_CONF['layout_url']}/images/$arrow.$_IMAGE_TYPE";
    $img_arrow = '&nbsp;' . COM_createImage($img_arrow_url, $arrow);

    if (!empty ($order_for_query)) { # concat order string
        $order_sql = "ORDER BY $order_for_query $direction";
    }
    $th_subtags = ''; // other tags in the th, such as onclick and mouseover
    $header_text = ''; // title as displayed to the user
    // HEADER FIELDS array(text, field, sort, class)
    // this part defines the contents & format of the header fields

    for ($i=0; $i < count( $header_arr ); $i++) { #iterate through all headers
        $header_text = $header_arr[$i]['text'];
        $th_subtags = '';
        if ($header_arr[$i]['sort'] != false) { # is this sortable?
            if ($order==$header_arr[$i]['field']) { # is this currently sorted?
                $header_text .= $img_arrow;
            }
            # make the mouseover effect is sortable
            $th_subtags = " onmouseover=\"this.style.cursor='pointer';\"";
            $order_var = $i; # assign number to field so we know what to sort
            if (strpos ($form_url, '?') > 0) {
                $separator = '&amp;';
            } else {
                $separator = '?';
            }
            $th_subtags .= " onclick=\"window.location.href='$form_url$separator" // onclick action
                    ."order=$order_var&amp;prevorder=$order&amp;direction=$direction";
            if (!empty($page)) {
                $th_subtags .= '&amp;' . $component . 'listpage=' . $page;
            }
            if (!empty($query)) {
                $th_subtags .= '&amp;q=' . urlencode($query);
            }
            if (!empty($query_limit)) {
                $th_subtags .= '&amp;query_limit=' . $query_limit;
            }
            $th_subtags .= "';\"";
        }

        if (!empty($header_arr[$i]['header_class'])) {
            $admin_templates->set_var('class', $header_arr[$i]['header_class']);
        } else {
            $admin_templates->set_var('class', "admin-list-headerfield");
        }
        $admin_templates->set_var('header_text', $header_text);
        $admin_templates->set_var('th_subtags', $th_subtags);
        $admin_templates->parse('header_row', 'header', true);
        $admin_templates->clear_var('th_subtags'); // clear all for next header
        $admin_templates->clear_var('class');
        $admin_templates->clear_var('header_text');
    }

    if ($has_extras) {
	
        $limit = 50; # default query limit if not other chosen.
                     # maybe this could be a setting from the list?
        if (!empty($query_limit)) {
            $limit = $query_limit;
        }
        if ($query != '') { # set query into form after search
            $admin_templates->set_var ('query', urlencode($query) );
        } else {
            $admin_templates->set_var ('query', '');
        }
        $admin_templates->set_var ('query_limit', $query_limit);
        # choose proper dropdown field for query limit
        $admin_templates->set_var($limit . '_selected', 'selected="selected"');

        if (!empty($query_arr['default_filter'])){ # add default filter to sql
            $filter_str = " {$query_arr['default_filter']}";
        }
        if (!empty ($query)) { # add query fields with search term
            $filter_str .= " WHERE (";
            for ($f = 0; $f < count($query_arr['query_fields']); $f++) {
                $filter_str .= $query_arr['query_fields'][$f]
                            . " LIKE '%$sql_query%'";
                if ($f < (count($query_arr['query_fields']) - 1)) {
                    $filter_str .= " OR ";
                }
            }
            $filter_str .= ")";
        }
        $num_pages_sql = $sql . $filter_str;
        $num_pages_result = DB_query($num_pages_sql);
        $num_rows = DB_numRows($num_pages_result);
        $num_pages = ceil ($num_rows / $limit);
        if ($num_pages < $curpage) { # make sure we dont go beyond possible results
               $curpage = 1;
        }
        $offset = (($curpage - 1) * $limit);
        $limit = "LIMIT $offset,$limit"; # get only current page data
        $admin_templates->set_var ('lang_records_found',
                                   $LANG_ADMIN['records_found']);
        $admin_templates->set_var ('records_found',
                                   COM_numberFormat ($num_rows));
        $admin_templates->parse('search_menu', 'search', true);
    }

    # SQL
    $sql .= "$filter_str $order_sql $limit;";
//echo "sql = ".$sql;
    $result = DB_query($sql);
    $nrows = DB_numRows($result);
    $r = 1; # r is the counter for the actual displayed rows for correct coloring
    for ($i = 0; $i < $nrows; $i++) { # now go through actual data
        $A = DB_fetchArray($result);
        $this_row = false; # as long as no fields are returned, dont print row

        for ($j = 0; $j < count($header_arr); $j++) {
            $fieldname = $header_arr[$j]['field']; # get field name from headers
            $fieldvalue = '';
            if (!empty($A[$fieldname])) { # is there a field in data like that?

// show the icon if if it the shareimage field
			if ($fieldname == "shareimage"){
					$fieldvalue = '<img src="'.$_CONF['site_url'].'/socialshare/images/'.$A[$fieldname].'" alt="Edit">'; # yes, get its data
				}else{
					$fieldvalue = $A[$fieldname]; # yes, get its data
				}

            }
            if (!empty ($fieldfunction) && !empty ($extra)) {
                $fieldvalue = $fieldfunction ($fieldname, $fieldvalue, $A, $icon_arr, $extra);
            } else if (!empty ($fieldfunction)) { # do we have a fieldfunction?
                $fieldvalue = $fieldfunction ($fieldname, $fieldvalue, $A, $icon_arr);
            } else { # if not just take the value
                $fieldvalue = $fieldvalue;
            }
            if ($fieldvalue !== false) { # return was there, so write line
                $this_row = true;
            } else {
                $fieldvalue = ''; // dont give emtpy fields
            }
            if (!empty($header_arr[$j]['field_class'])) {
                $admin_templates->set_var('class', $header_arr[$j]['field_class']);
            } else {
                $admin_templates->set_var('class', "admin-list-field");
            }
			

            $admin_templates->set_var('itemtext', $fieldvalue); # write field
			
            $admin_templates->parse('item_field', 'field', true);
        }
        if ($this_row) { # there was data in at least one field, so print line
            $r++; # switch to next color
            $admin_templates->set_var('cssid', ($r%2)+1); # make alternating table color
            $admin_templates->parse('item_row', 'row', true); # process the complete row
        }
        $admin_templates->clear_var('item_field'); # clear field
    }

    if ($nrows==0) { # there is no data. return notification message.
        if (isset($text_arr['no_data'])) {
            $message = $text_arr['no_data']; # there is a user-message
        } else {
            $message = $LANG_ADMIN['no_results']; # take std.
        }
        $admin_templates->set_var('message', $message);
    }

    if ($has_extras) { # now make google-paging
        $hasargs = strstr( $form_url, '?' );
        if( $hasargs ) {
            $sep = '&amp;';
        } else {
            $sep = '?';
        }
        if (!empty($query)) { # port query to next page
            $base_url = $form_url . $sep . 'q=' . urlencode($query) . "&amp;query_limit=$query_limit$order_var_link&amp;direction=$direction";
        } else {
            $base_url = $form_url . $sep ."query_limit=$query_limit$order_var_link&amp;direction=$direction";
        }

        if ($num_pages > 1) { # print actual google-paging
            $admin_templates->set_var('google_paging',COM_printPageNavigation($base_url,$curpage,$num_pages, $component . 'listpage='));
        } else {
            $admin_templates->set_var('google_paging', '');
        }
    }

    $admin_templates->parse('output', 'list');

    // Do the actual output
    if (!empty($title)) {
        $retval .= COM_startBlock($title, $help_url,
                            COM_getBlockTemplate('_admin_block', 'header'));
    }
    $retval .= $admin_templates->finish($admin_templates->get_var('output'));
    if (!empty($title)) {
        $retval .= COM_endBlock(COM_getBlockTemplate('_admin_block', 'footer'));
    }

    return $retval;
}




/**
* Creates a menu with an optional icon and optional text below
* this is used in the admin screens but may be used elsewhere also.
*
* @param    array   $menu_arr       array of text & URL of the menu entries
* @param    string  $text           instructions to be displayed
* @param    string  icon            url of an icon that will be displayed
* @return   string                  HTML output of function
*
*/
function SHARE_createMenu($menu_arr, $text, $icon = '')
{
    global $_CONF;

    $admin_templates = new Template($_CONF['path_html'] . 'admin/plugins/socialshare/templates/lists');
    $admin_templates->set_file (
        array ('top_menu' => 'topmenu.thtml')
    );

    $menu_fields = '';
    $attr = array('class' => 'admin-menu-item');
    for ($i = 0; $i < count($menu_arr); $i++) {
        $menu_fields .= COM_createLink($menu_arr[$i]['text'], $menu_arr[$i]['url'], $attr);
        if ($i < (count($menu_arr) -1)) {
            $menu_fields .= ' | ';
        }
    }
    if (!empty ($icon)) {
        $attr = array('class' => 'admin-menu-icon');
        $icon = COM_createImage($icon, '', $attr);
        $admin_templates->set_var('icon', $icon);
    }
    $admin_templates->set_var('menu_fields', $menu_fields);
    $admin_templates->set_var('lang_instructions', $text);
    $admin_templates->set_var('xhtml', XHTML);
    $admin_templates->set_var('site_url', $_CONF['site_url']);
    $admin_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
    $admin_templates->set_var('layout_url', $_CONF['layout_url']);
    $admin_templates->parse('top_menu', 'top_menu');
    $retval = $admin_templates->finish($admin_templates->get_var('top_menu'));
    return $retval;
}



/**
 * used for the list of items in admin/plugins/socialshare/index.php
 *
 */
function SHARE_getListField($fieldname, $fieldvalue, $A, $icon_arr, $token)
{
    global $_CONF, $LANG_ADMIN, $LANG21, $_IMAGE_TYPE, $LANG_SOCIALSHARE_0;

    $retval = false;

    $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);

    if ($access > 0)  {
        switch($fieldname) {
            case 'edit':
                if ($access == 3) {
                    $retval = COM_createLink($icon_arr['edit'],
                        "{$_CONF['site_admin_url']}/plugins/socialshare/index.php?mode=edit&amp;sid={$A['sid']}");

                }
                break;
            case 'title':
                $retval = stripslashes ($A['title']);
                if (empty ($retval)) {
                    $retval = '(' . $A['name'] . ')';
                }
                break;
            case 'shareorder':
                $retval .= $A['shareorder'];
                break;
            case 'is_enabled':
                if ($access == 3) {
                    if ($A['is_enabled'] == 1) {
                        $switch = ' checked="checked"';
                    } else {
                        $switch = '';
                    }
                    $retval = "<input type=\"checkbox\" name=\"enabledshare[{$A['sid']}]\" "
                        . "onclick=\"submit()\" value=\"{$A['onleft']}\"$switch" . XHTML . ">";
                    $retval .= "<input type=\"hidden\" name=\"" . CSRF_TOKEN . "\" value=\"{$token}\"" . XHTML . ">";
                }
                break;
            case 'move':
                if ($access == 3) {
                        $sharecontrol_image = 'move-share.' . $_IMAGE_TYPE;
                    $retval.="<img src=\"{$_CONF['site_admin_url']}/plugins/socialshare/images/$sharecontrol_image\" width=\"45\" height=\"20\" usemap=\"#arrow{$A['sid']}\" alt=\"\"" . XHTML . ">"
                            ."<map id=\"arrow{$A['sid']}\" name=\"arrow{$A['sid']}\">"
                            ."<area coords=\"0,0,12,20\"  title=\"{$LANG_SOCIALSHARE_0[25]}\" href=\"{$_CONF['site_admin_url']}/plugins/socialshare/index.php?mode=move&amp;sid={$A['sid']}&amp;where=up&amp;".CSRF_TOKEN."={$token}\" alt=\"{$LANG_SOCIALSHARE_0[25]}\"" . XHTML . ">"
//                            ."<area coords=\"13,0,29,20\" title=\"$moveTitleMsg\" href=\"{$_CONF['site_admin_url']}/plugins/socialshare/index.php?mode=move&amp;sid={$A['sid']}&amp;where=$switchside&amp;".CSRF_TOKEN."={$token}\" alt=\"$moveTitleMsg\"" . XHTML . ">"
                            ."<area coords=\"30,0,43,20\" title=\"{$LANG_SOCIALSHARE_0[26]}\" href=\"{$_CONF['site_admin_url']}/plugins/socialshare/index.php?mode=move&amp;sid={$A['sid']}&amp;where=dn&amp;".CSRF_TOKEN."={$token}\" alt=\"{$LANG_SOCIALSHARE_0[26]}\"" . XHTML . ">"
                            ."</map>";
                }
                break;
            default:
                $retval = $fieldvalue;
                break;
        }
    }
    return $retval;
}



/**
* Saves a Share item
*
* @return   string                  HTML redirect or error message
*
*/
function saveshare ($sid, $shareorder, $shareurl, $sharetitle, $shareimage, $is_enabled, $owner_id)
{
    global $_CONF, $_TABLES, $LANG01, $LANG21, $MESSAGE, $LANG_SOCIALSHARE_0;

    $retval = '';
	
    $sharetitle = addslashes (COM_stripslashes (strip_tags ($sharetitle)));

    if (empty($sharetitle)) {
        $retval .= COM_siteHeader ('menu', $LANG_SOCIALSHARE_0[13])
                . COM_startBlock ($LANG_SOCIALSHARE_0[13], '',
                          COM_getBlockTemplate ('_msg_block', 'header'))
                . $LANG_SOCIALSHARE_0[12]
                . COM_endBlock (COM_getBlockTemplate ('_msg_block',
                                                      'footer'))
                . editshare ($sid)
                . COM_siteFooter ();
        return $retval;
    }


	if (!empty($sharetitle) && !empty($shareurl) && !empty($shareimage) ) {	
        if ($is_enabled == 'on') {
            $is_enabled = 1;
        } else {
            $is_enabled = 0;
        }
echo "<br>share order = ".$shareorder;
echo "<br>share url = ".$shareurl;
echo "<br>share title = ".$sharetitle;
echo "<br>share image = ".$shareimage;
echo "<br>is_enabled = ".$is_enabled;
echo "<br>owner id = ".$ownerid;
// If this is an existing record then save the updated values otherwise insert a new record
        if ($sid > 0) {
            DB_save($_TABLES['socialshare'],'sid,shareorder, shareurl, sharetitle, shareimage, is_enabled, owner_id',"$sid,'$shareorder','$shareurl','$sharetitle','$shareimage',$is_enabled,$owner_id");
        } else {
            $sql = "INSERT INTO {$_TABLES['socialshare']} "
             .'(shareorder,shareurl,sharetitle,shareimage,is_enabled,owner_id) '
             ."VALUES ('$shareorder','$shareurl','$sharetitle','$shareimage',$is_enabled,$owner_id)";
             DB_query($sql);
             $sid = DB_insertId();
        }
        return COM_refresh ($_CONF['site_admin_url'] . '/plugins/socialshare/index.php?ssmsg=16');
    } else {
        $retval .= COM_siteHeader ('menu', $LANG21[32])
                . COM_startBlock ($LANG21[32], '',
                          COM_getBlockTemplate ('_msg_block', 'header'));

            $retval .= $LANG21[32];		
        $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'))
                . editshare ($sid)
                . COM_siteFooter ();
    }

    return $retval;
}



/**
*
* Re-orders all entries in steps of 10
*
*/
function reordershare()
{
    global $_TABLES;
    $sql = "SELECT * FROM {$_TABLES['socialshare']} ORDER BY shareorder asc;";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);

    $lastside = 0;
    $shareOrd = 10;
    $stepNumber = 10;

    for ($i = 0; $i < $nrows; $i++) {
        $A = DB_fetchArray($result);

        if ($A['shareorder'] != $shareOrd) {  
            $q = "UPDATE " . $_TABLES['socialshare'] . " SET shareorder = '" .
                  $shareOrd . "' WHERE sid = '" . $A['sid'] ."'";
            DB_query($q);
        }
        $shareOrd += $stepNumber;

    }
}


/**
* Move selections UP, Down
*
*/
function moveShare()
{
    global $_CONF, $_TABLES;

    $retval = '';

    $sid = COM_applyFilter($_GET['sid']);
    $where = COM_applyFilter($_GET['where']);

    // if the selection id exists
    if (DB_count($_TABLES['socialshare'], "sid", $sid) == 1) {

        switch ($where) {

            case ("up"): $q = "UPDATE " . $_TABLES['socialshare'] . " SET shareorder = shareorder-11 WHERE sid = '" . $sid . "'";
                         DB_query($q);
                         break;

            case ("dn"): $q = "UPDATE " . $_TABLES['socialshare'] . " SET shareorder = shareorder+11 WHERE sid = '" . $sid . "'";
                         DB_query($q);
                         break;
        }

    } else {
        COM_errorLOG("socialshare admin error: Attempt to move an non existing item id: $sid");
    }
    echo COM_refresh($_CONF['site_admin_url'] . "/plugins/socialshare/index.php");
    exit;
    return $retval;
}


/**
* Enable and Disable an item
*/
function changeShareStatus($side, $sid_arr)
{
    global $_CONF, $_TABLES;

    $side = COM_applyFilter($side, true);
    $sql = "UPDATE {$_TABLES['socialshare']} SET is_enabled = '0';";
    DB_query($sql);

    if (isset($sid_arr)) {

        foreach ($sid_arr as $sid => $side) {
            $sid = COM_applyFilter($sid, true);
            // the enable those in the array
            $sql = "UPDATE {$_TABLES['socialshare']} SET is_enabled = '1' WHERE sid='$sid'";
            DB_query($sql);
        }
    }
    return;
}

/**
* Delete an item
*
* @param    string  $sid    id of item to delete
* @return   string          HTML redirect or error message
*
*/
function deleteShare($sid)
{
    global $_CONF, $_TABLES, $_USER;

    DB_delete ($_TABLES['socialshare'], 'sid', $sid);

    return COM_refresh ($_CONF['site_admin_url'] . '/plugins/socialshare/index.php?ssmsg=15');
}
//---------------------------------------------




// MAIN




$mode = '';
if (!empty($_REQUEST['mode'])) {
    $mode = $_REQUEST['mode'];
}


$sid = '';
if (!empty($_REQUEST['sid'])) {
    $sid = COM_applyFilter ($_REQUEST['sid']);
}

//if the enabled checkbox was clicked then call changeShareStatus()
if (isset($_POST['shareenabler']) && SEC_checkToken()) {
    $enabledshare = array();
    if (isset($_POST['enabledshare'])) {
        $enabledshare = $_POST['enabledshare'];
    }
    changeShareStatus($_POST['shareenabler'], $enabledshare);
}

//if Delete then call deleteShare() or log the failure
if (($mode == $LANG_SOCIALSHARE_0[8]) && !empty ($LANG_SOCIALSHARE_0[8])) {
    if (!isset ($sid) || empty ($sid) || ($sid == 0)) {
        COM_errorLog ('Attempted to delete Share item, sid empty or null, value =' . $sid);
        $display .= COM_refresh ($_CONF['site_admin_url'] . '/plugins/socialshare/index.php');
    } elseif (SEC_checkToken()) {
        $display .= deleteShare($sid);
    } else {
        COM_accessLog("User {$_USER['username']} tried to illegally delete Share item $sid and failed CSRF checks.");
        echo COM_refresh($_CONF['site_admin_url'] . '/index.php');
    }
//if Save then validate the data and call saveShare()
//if data is not complete then call editShare()	
} elseif (($mode == $LANG_SOCIALSHARE_0[3]) && !empty($LANG_SOCIALSHARE_0[3]) && SEC_checkToken()) {
    $shareorder = '';
    if (isset ($_POST['shareorder'])) {
        $shareorder = $_POST['shareorder'];
    }
    $shareurl = '';
    if (isset ($_POST['shareurl'])) {
        $shareurl = $_POST['shareurl'];
    }
    $sharetitle = '';
    if (isset ($_POST['sharetitle'])) {
        $sharetitle = $_POST['sharetitle'];
    }
    $shareimage = '';
    if (isset ($_POST['shareimage'])) {
        $shareimage = $_POST['shareimage'];
    }
    $is_enabled = '';
    if (isset ($_POST['is_enabled'])) {
        $is_enabled = $_POST['is_enabled'];
    }
	$owner_id = $_USER['uid'];
    $display .= saveshare ($sid, $_POST['shareorder'], $_POST['shareurl'], $_POST['sharetitle'], $_POST['shareimage'], $is_enabled, $owner_id);

//If Edit then call editShare()	
	} else if ($mode == 'edit') {
    $display .= COM_siteHeader ('menu', $LANG_SOCIALSHARE_0[1])
             . editshare ($sid)
             . COM_siteFooter ();

//If Move then call moveShare()			 
	} else if ($mode == 'move') {
    $display .= COM_siteHeader('menu', $LANG_SOCIALSHARE_0[17]);
    if(SEC_checkToken()) {
        $display .= moveShare();
    }
    $display .= listshare();
    $display .= COM_siteFooter();

// 'cancel' or no mode at all
	} else {  

$display .= COM_siteHeader('menu', $LANG_SOCIALSHARE_0[17]);
$display .= COM_startBlock($LANG_SOCIALSHARE_0[17]);
$display .= '<p>Welcome to the ' . $LANG_SOCIALSHARE_0[17] . ' plugin, '
         . $_USER['username'] . '!</p>';


//    $display .= COM_siteHeader('menu', $LANG_SOCIALSHARE_0[17]);
//    $display .= COM_showMessageFromParameter();

//Check to see if there are any messages in the URL and display the text if there is
	if ($_GET['ssmsg']){
		$display .= COM_showMessagetext($LANG_SOCIALSHARE_0[$_GET['ssmsg']]);
	}

//The default is to show the list via listShare()	
    $display .= listshare();
    $display .= COM_siteFooter();
}

//Show us what you got
COM_output($display);


?>
