<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | SocialShare Plugin 1.2                                                    |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API methods and 2) implements all the common code needed by this plugin.  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009-2011 by the following authors:                         |
// |                                                                           |
// | Authors: Greg Gillis - greg DOT gillis AT sillig DOT com                  |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package SocialShare
*/

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die ('This file can not be used on its own.');
}



/**
 * Language file include
 */
$plugin_path = $_CONF['path'] . 'plugins/socialshare/';
$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';

if (file_exists($langfile)) {
    require_once $langfile;
} else {
    require_once $plugin_path . 'language/english.php';
}

/**
 * Config file include
 */

    require_once $plugin_path . 'config.php';

	
/**
 * SocialShare plugin table(s)
 */
$_TABLES['socialshare'] = $_DB_table_prefix . 'socialshare';


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementation                                         |
// +---------------------------------------------------------------------------+

/**
* Returns the item(s) for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* @return   mixed   menu entry, or boolean false if disabled / hidden
*
*/

/** We don't need a menu item at this point
function plugin_getmenuitems_socialshare()
{
    global $_CONF, $LANG_SOCIALSHARE_0;

    $url = $_CONF['site_url'] . '/socialshare/index.php';
    $menuitems[$LANG_SOCIALSHARE_0[17]]= $url;

    return $menuitems;
}
*/

/**
* Geeklog is asking us to provide any items that show up in the type
* drop-down on search.php.  Let's users search for links.
*
* @return   array   (plugin name/entry title) pair for the dropdown
*
*/
/*
function plugin_searchtypes_socialshare()
{
    global $LANG_SOCIALSHARE_0

    $tmp['socialshare'] = $LANG_SOCIALSHARE_0[17];

    return $tmp;
}
*/

/**
* This searches for entries matching the user query and returns an array for the
* header and table rows back to search.php where it will be formated and printed
*
* @param    string  $query      Keywords user is looking for
* @param    date    $datestart  Start date to get results for
* @param    date    $dateend    End date to get results for
* @param    string  $topic      The topic they were searching in
* @param    string  $type       Type of items they are searching, or 'all' (deprecated)
* @param    int     $author     Get all results by this author
* @param    string  $keyType    search key type: 'all', 'phrase', 'any'
* @param    int     $page       page number of current search (deprecated)
* @param    int     $perpage    number of results per page (deprecated)
* @return   object              search result object
*
*/
/*
function plugin_dopluginsearch_socialshare($query, $datestart, $dateend, $topic, $type, $author, $keyType, $page, $perpage)
{
    global $_TABLES, $LANG_SOCIALSHARE_0;

    // Make sure the query is SQL safe
    $query = trim(addslashes($query));

    // NOTE: Update SQL query to match the actual table used by the
    //       SocialShare plugin!

    $sql = "SELECT sid AS id, title, description, UNIX_TIMESTAMP(date) AS date, owner_id AS uid, hits, ";
    $sql .= "CONCAT('/socialshare/index.php?item=', sid) AS url ";
    $sql .= "FROM {$_TABLES['socialshare']} WHERE date <> 1 ";
    $sql .= COM_getPermSQL('AND') . ' ';

    if (!empty($datestart) && !empty($dateend)) {
        $delim = substr($datestart, 4, 1);
        if (!empty($delim)) {
            $DS = explode($delim, $datestart);
            $DE = explode($delim, $dateend);
            $startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
            $enddate = mktime(23,59,59,$DE[1],$DE[2],$DE[0]);
            $sql .= "AND (UNIX_TIMESTAMP(date) BETWEEN '$startdate' AND '$enddate') ";
        }
    }
    if (!empty ($author)) {
        $sql .= "AND (owner_id = '$author') ";
    }

    $search = new SearchCriteria('socialshare', $LANG_SOCIALSHARE_0[17]);
    $columns = array('title', 'description');
    list($sql,$ftsql) = $search->buildSearchSQL($keyType, $query, $columns, $sql);
    $search->setSQL($sql);
    $search->setFTSQL($ftsql);
    $search->setRank(3);

    return $search;
}
*/

/**
* Implements a [socialshare:] autotag.
*
* @param    string  $op         operation to perform
* @param    string  $content    item (e.g. story text), including the autotag
* @param    array   $autotag    parameters used in the autotag
* @param    mixed               tag names (for $op='tagname') or formatted content
*
*/
/*
function plugin_autotags_socialshare($op, $content = '', $autotag = '')
{
    global $_CONF, $_TABLES, $LANG_SOCIALSHARE_0;

    if ($op == 'tagname') {
        return 'socialshare';
    } elseif ($op == 'parse') {
        $sid = COM_applyFilter($autotag['parm1']);
        if (! empty($sid)) {
            $url = $_CONF['site_url'] . '/socialshare/index.php?item=' . $sid);
            if (empty($autotag['parm2'])) {
                $linktext = 'SocialShare'; // or get title from db
            } else {
                $linktext = $autotag['parm2'];
            }
            $link = COM_createLink($linktext, $url);
            $content = str_replace($autotag['tagstr'], $link, $content);
        }

        return $content;
    }
}
*/

/**
* Return plugin entry for "Command and Control" (moderation.php)
*
* @return  array  Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_socialshare()
{
    global $_CONF, $LANG_SOCIALSHARE_0;

    $retval = array();
    if (SEC_hasRights('socialshare.admin')) {
        $retval = array($LANG_SOCIALSHARE_0[17],
            $_CONF['site_admin_url'] . '/plugins/socialshare/index.php',
            plugin_geticon_socialshare());
    }

    return $retval;
}

/**
* Return plugin entry for the Admins Only block
*
* @return array Array containing (plugin name, plugin admin url, # of plugin items or '')
*/
function plugin_getadminoption_socialshare()
{
    global $_CONF, $LANG_SOCIALSHARE_0;

    if (SEC_hasRights('socialshare.admin')) {
        return array($LANG_SOCIALSHARE_0[17],
            $_CONF['site_admin_url'] . '/plugins/socialshare/index.php', 0);
    }
}

/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/
function plugin_geticon_socialshare()
{
    global $_CONF;

    // popular alternative location:
    // return $_CONF['site_url'] . '/socialshare/images/socialshare.png';

    return $_CONF['site_admin_url'] . '/plugins/socialshare/images/socialshare.png';
}

/**
 * Returns the current plugin code version
 *
 * @return string    plugin version
 */
function plugin_chkVersion_socialshare()
{
    global $_CONF;

    require_once $_CONF['path'] . 'plugins/socialshare/autoinstall.php';

    $inst_parms = plugin_autoinstall_socialshare('socialshare');

    return $inst_parms['info']['pi_version'];
}

/**
* Update the plugin
*
* @return   int     Number of message to display or true for success
*
*/
function plugin_upgrade_socialshare()
{
    global $_CONF, $_TABLES;

    $installed_version = DB_getItem($_TABLES['plugins'], 'pi_version',
                                    "pi_name = 'socialshare'");
    $code_version = plugin_chkVersion_socialshare();
    if ($installed_version == $code_version) {
        // nothing to do
        return true;
    }

    require_once $_CONF['path'] . 'plugins/socialshare/autoinstall.php';

    if (! plugin_compatible_with_this_version_socialshare('socialshare')) {
        return 3002;
    }

    // other update code goes here

    // update plugin version number
    $inst_parms = plugin_autoinstall_socialshare('socialshare');
    $pi_gl_version = $inst_parms['info']['pi_gl_version'];

    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version = '$code_version', pi_gl_version = '$pi_gl_version' WHERE pi_name = 'socialshare'");

    return true;
}

/**
* Automatic uninstall function for plugins
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
* @return   array   Plugin information
*
*/
function plugin_autouninstall_socialshare()
{
    $out = array (
        /* give the name of the tables, without $_TABLES[] */
        'tables' => array('socialshare'),
        /* give the full name of the group, as in the db */
        'groups' => array('SocialShare Admin'),
        /* give the full name of the feature, as in the db */
        'features' => array('socialshare.admin'),
        /* give the full name of the block, including 'phpblock_', etc */
        'php_blocks' => array(),
        /* give all vars with their name */
        'vars' => array()
    );

    return $out;
}


/**
*
* IF PLG_ITEMDISPLAY is ever approved for inclusion in lib-story.php then disable plugin_templateSetVars_socialshare
* This function is only used for the admin page
*/

function plugin_itemdisplay_socialshare($id, $type)
{
    global $_CONF, $LANG_SOCIALSHARE_0, $LANG_SOCIALSHARE_0, $_TABLES, $A;

    $retval = array();

    $sql = "SELECT * FROM {$_TABLES['socialshare']} WHERE is_enabled=1 ORDER BY shareorder asc;";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);

$html = '<link rel="stylesheet" href="'.$_CONF['site_url'].'/socialshare/sociable.css" type="text/css" media="screen" charset="utf-8"/>';
$html .='<div class="sociable"><div class="sociable_tagline">'.$LANG_SOCIALSHARE_0[14].'</div><ul>';

    for ($i = 0; $i < $nrows; $i++) {
        $B = DB_fetchArray($result);

		if ($i == 1){
		$html .= '<li class="sociablefirst">';
		}else{
		$html .= '<li>';
		}

		
	
		
//$B['shareurl'] = str_replace('<SHAREURL>', $_CONF['site_url'].'/article.php?story='.$A['sid'], $B['shareurl']);
//$B['shareurl'] = str_replace('<SHARETITLE>', $A['title'], $B['shareurl']);
//$B['shareurl'] = str_replace('<SHARETEXT>', (substr($A['6'], 0, 150)), $B['shareurl']);
//------start fix
//Bug fix reported by Cordiste
//fix Code by Kenji(mystral-kk)
//Thanks guys
if (!isset($A['sid']) && $type != "admin_page") {

   $story_id  = $template->get_var('story_id');
   $title     = $template->get_var('story_title');
   $introtext = $template->get_var('story_introtext');

} else {

   $story_id  = $A['sid'];
   $title     = $A['title'];
   $introtext = $A['introtext'];

}

$story_uri = COM_buildURL($_CONF['site_url'] . '/article.php?story=' . $story_id);

$B['shareurl'] = str_replace('<SHAREURL>', $story_uri, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETITLE>', $title, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETEXT>', (COM_truncate($introtext, 150, '...')), $B['shareurl']);
//------end fix

		
//        if ($B['shareorder'] ) {
		
//        }
//		$html .= '<a rel="nofollow" target="_blank" width="626" height="436" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'"><img src="'.$_CONF['site_url'].'/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="sociable-hovers" /></a></li>';
		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'" onclick="window.open(this.href, \'popupwindow\', \'width=750,height=436,scrollbars,resizable\'); return false;"><img src="'.$_CONF['site_url'].'/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="sociable-hovers" /></a></li>';
//<a href="http://ozoneasylum.com" onclick="window.open(this.href, 'popupwindow', 'width=500,height=500,scrollbars,resizable'); return false;">popup</a> 

	}

		$html .= '</ul></div>';

	    $retval = array("SocialShare","{$html}");		
		
    return $retval;
}



/**
*
*
*/
function plugin_templateSetVars_socialshare($templatename, $template)
{
    global $_CONF, $CONF_SOCIALSHARE, $LANG_SOCIALSHARE_0, $LANG_SOCIALSHARE_0, $_TABLES, $A;

    $retval = array();

    $sql = "SELECT * FROM {$_TABLES['socialshare']} WHERE is_enabled=1 ORDER BY shareorder asc;";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);

$html = '<link rel="stylesheet" href="'.$_CONF['site_url'].'/socialshare/sociable.css" type="text/css" media="screen" charset="utf-8"/>';
$html .='<div class="sociable"><div class="sociable_tagline">'.$LANG_SOCIALSHARE_0[14].'</div><ul>';

    for ($i = 0; $i < $nrows; $i++) {
        $B = DB_fetchArray($result);

		if ($i == 1){
		$html .= '<li class="sociablefirst">';
		}else{
		$html .= '<li>';
		}

		
//$B['shareurl'] = str_replace('<SHAREURL>', $_CONF['site_url'].'/article.php?story='.$A['sid'], $B['shareurl']);
//$B['shareurl'] = str_replace('<SHARETITLE>', $A['title'], $B['shareurl']);
//$B['shareurl'] = str_replace('<SHARETEXT>', (substr($A['6'], 0, 150)), $B['shareurl']);

//------start fix
//Bug fix reported by Cordiste
//fix Code by Kenji(mystral-kk)
//Thanks guys
if (!isset($A['sid'])) {

   $story_id  = $template->get_var('story_id');
   $title     = $template->get_var('story_title');
   $introtext = $template->get_var('story_introtext');

} else {

   $story_id  = $A['sid'];
   $title     = $A['title'];
   $introtext = $A['introtext'];

}

$story_uri = COM_buildURL($_CONF['site_url'] . '/article.php?story=' . $story_id);

$B['shareurl'] = str_replace('<SHAREURL>', $story_uri, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETITLE>', $title, $B['shareurl']);

$B['shareurl'] = str_replace('<SHARETEXT>', (COM_truncate($introtext, 150, '...')), $B['shareurl']);
//------end fix

        if ($B['shareorder'] ) {
		
        }

// if the config file is set to 0 then do the onclick popup method
	if ($CONF_SOCIALSHARE['popup'] == 0){

		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'" onclick="window.open(this.href, \'popupwindow\', \'width=750,height=436,scrollbars,resizable\'); return false;"><img src="'.$_CONF['site_url'].'/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="sociable-hovers" /></a></li>';

// if the config file is set to 1 then do the _blank popup method		
	} elseif ($CONF_SOCIALSHARE['popup'] == 1){

		$html .= '<a rel="nofollow" target="_blank" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'"><img src="'.$_CONF['site_url'].'/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="sociable-hovers" /></a></li>';

// if the config file is set to 2 then use the same browser instance		
	} elseif ($CONF_SOCIALSHARE['popup'] == 2){

		$html .= '<a rel="nofollow" href="'.strip_tags($B['shareurl']).'" title="'.$B['sharetitle'].'"><img src="'.$_CONF['site_url'].'/socialshare/images/'.$B['shareimage'].'" title="'.$B['sharetitle'].'" alt="'.$B['sharetitle'].'" class="sociable-hovers" /></a></li>';
		
	}


}
$html .= '</ul></div>';

//
    if ($templatename == 'storytext' || $templatename == 'featuredstorytext'|| $templatename == 'archivestorytext') {
        $template->set_var ('socialshareicons', $html);
    }

}
?>